#include <QDebug>
#include <QSettings>
#include "utils.h"

Utils::Utils()
{
}

void Utils::writeEntry(QString filepath, QString key, QString value, QString group)
{
    QSettings settings(filepath, QSettings::IniFormat);
    qDebug() << filepath << group + "/" + key << value;
    settings.setValue(group + "/" + key, value);
}

QString Utils::ReadEntry(QString filepath, QString key, QString group)
{
    QSettings settings(filepath, QSettings::IniFormat);
    return settings.value(group + "/" + key, QString()).toString();
}

QString Utils::getIconTheme()
{
    QProcess p;
    #ifdef __arm__
        p.start("gksu --u pi \"xfconf-query -c xsettings -p /Net/IconThemeName\"");
    #else
        p.start("xfconf-query -c xsettings -p /Net/IcoThemeName");
    #endif
    p.waitForFinished();
    QString r(p.readAllStandardOutput());
    if (r.simplified() == "") {
        return "elementary-xfce";
    }
    else{
        return r.simplified();
    }
}
