#include "main.h"
int main(int argc, char *argv[])
{
    Application *a = new Application(argc,argv);

    bool hideCursor = false;
    int delay = 0;
    QFile file(CONFFILE);
    if(file.open(QFile::ReadOnly |
                  QFile::Text))
    {
        bool parse = false;
        QTextStream in(&file);
        while (!in.atEnd())
        {
          QString line = in.readLine();
          if(line == "")
              parse = false;
          if(line == "[default]")
              parse = true;

          QStringList list = line.split("=");
          if((list.at(0) == "command") && parse)
          {
              a->cmd = list.at(1);
          }
          if((list.at(0) == "hidecursor" && list.at(1)=="true") && parse)
          {
              hideCursor = true;
          }
          if((list.at(0) == "delay") && parse)
          {
              delay = list.at(1).toInt();
          }
          if(list.at(0) == "noscreensaver" && parse)
          {
              if(list.at(1) == "true")
              {
                  QProcess p;
                  p.start("pkill -9 xscreensaver");
                  p.waitForFinished();
                  p.start("xset s off");
                  p.waitForFinished();
                  p.start("xset -dpms");
                  p.waitForFinished();
                  p.start("xset s noblank");
                  p.waitForFinished();
              }
          }
        }
        file.close();
    }
    if(a->cmd == "noop")
        return 0;
    if(delay)
    {
        sleep(delay);
    }
    if(hideCursor)
    {
        a->hide->start("unclutter");
    }

    a->connect(a->cmdProcess,SIGNAL(error(QProcess::ProcessError)),a,SLOT(restart(QProcess::ProcessError)));
    a->connect(a->cmdProcess,SIGNAL(finished(int,QProcess::ExitStatus)),a,SLOT(needRestart(int,QProcess::ExitStatus)));

    a->cmdProcess->start(a->cmd);
    a->cmdProcess->waitForStarted(-1);
    if(a->cmd.split(" ")[0] == "flashplayer")
    {
        sleep(5);
        system("xdotool key ctrl+f");
    }
    a->cmdProcess->waitForFinished(-1);
}

void Application::start()
{
    disconnect(cmdProcess,SIGNAL(error(QProcess::ProcessError)),this,SLOT(restart(QProcess::ProcessError)));
    disconnect(cmdProcess,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(needRestart(int,QProcess::ExitStatus)));
    cmdProcess->kill();
    cmdProcess = new QProcess();
    connect(cmdProcess,SIGNAL(error(QProcess::ProcessError)),this,SLOT(restart(QProcess::ProcessError)));
    connect(cmdProcess,SIGNAL(finished(int,QProcess::ExitStatus)),this,SLOT(needRestart(int,QProcess::ExitStatus)));

    cmdProcess->start(cmd);
    cmdProcess->waitForStarted(-1);
    if(cmd.split(" ")[0] == "flashplayer")
    {
        sleep(5);
        system("xdotool key ctrl+f");
    }
    cmdProcess->waitForFinished(-1);
}

void Application::restart(QProcess::ProcessError)
{
    start();
}

void Application::needRestart(int code, QProcess::ExitStatus error){
    if(error != QProcess::NormalExit || code != 0)
    {
        start();
    }
    else
    {
        hide->terminate();
        exit();
    }
}
